> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trysoma.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create envelope key

> Create a new envelope encryption key (master key) for encrypting data encryption keys



## OpenAPI

````yaml api-reference/openapi.json post /api/encryption/v1/envelope
openapi: 3.1.0
info:
  title: soma
  version: v1
servers: []
security: []
tags:
  - name: task
    description: >-
      Task management endpoints for creating, listing, and managing tasks and
      their messages
  - name: secret
    description: Secret management endpoints for storing and retrieving encrypted secrets
  - name: encryption
    description: >-
      Encryption key management endpoints for envelope keys, data encryption
      keys, and aliases
  - name: bridge
    description: >-
      Bridge endpoints for managing providers, credentials, functions, and MCP
      protocol communication
  - name: _internal
    description: >-
      Internal endpoints for health checks, runtime configuration, and SDK code
      generation
  - name: a2a
    description: >-
      Agent-to-agent communication endpoints for agent cards, definitions, and
      JSON-RPC requests
  - name: v1
    description: API version v1 endpoints
paths:
  /api/encryption/v1/envelope:
    post:
      tags:
        - encryption
        - v1
      summary: Create envelope key
      description: >-
        Create a new envelope encryption key (master key) for encrypting data
        encryption keys
      operationId: create-envelope-encryption-key
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/EnvelopeEncryptionKey'
        required: true
      responses:
        '200':
          description: Create envelope encryption key
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EnvelopeEncryptionKey'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '502':
          description: Bad Gateway
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
components:
  schemas:
    EnvelopeEncryptionKey:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/EnvelopeEncryptionKeyAwsKms'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - aws_kms
        - allOf:
            - $ref: '#/components/schemas/EnvelopeEncryptionKeyLocal'
            - type: object
              required:
                - type
              properties:
                type:
                  type: string
                  enum:
                    - local
    Error:
      type: object
      required:
        - message
      properties:
        data: {}
        message:
          type: string
    EnvelopeEncryptionKeyAwsKms:
      type: object
      required:
        - arn
        - region
      properties:
        arn:
          type: string
        region:
          type: string
    EnvelopeEncryptionKeyLocal:
      type: object
      required:
        - file_name
      properties:
        file_name:
          type: string

````